<?php
define('MODX_API_MODE', true);
require dirname(dirname(dirname(dirname(dirname(__FILE__))))) . '/index.php';

$modx->getService('error', 'error.modError');
$modx->setLogLevel(modX::LOG_LEVEL_ERROR);
$modx->setLogTarget('FILE');

$miniShop2 = $modx->getService('minishop2');
$miniShop2->loadCustomClasses('payment');

if (!class_exists('EasyPay')) {
    exit('Error: could not load payment class "EasyPay".');
}

$handler = new EasyPay($modx->newObject('msOrder'));
$web_key = $handler->modx->getOption('web_key');

if ($_GET['action'] == 'notify') {
// Получение данных
    $values = array();
    $values['order_mer_code'] = $_POST['order_mer_code'];
    $values['sum'] = $_POST['sum'];
    $values['mer_no'] = $_POST['mer_no'];
    $values['card'] = $_POST['card'];
    $values['purch_date'] = $_POST['purch_date'];
    $values['notify_signature'] = $_POST['notify_signature'];

    $signature_checked = validateRequests($values,$web_key);
    if ($signature_checked == 1) {
        $miniShop2->changeOrderStatus($_POST['order_mer_code'], 2); // Изменение статуса заказа на оплачен
        header("HTTP/1.0 200 OK");
        print $status = 'OK | the notice is processed'; //Все успешно
    } elseif ($signature_checked == 0) {
        header("HTTP/1.0 400 Bad Request");
        print $status = 'FAILED | incorrect digital signature'; //Ошибка вычисления электронной подписи
    } else {
        header("HTTP/1.0 400 Bad Request");
        print $status = 'FAILED | the notice is not processed'; //Ошибка в параметрах
    }
}

// Проверка электронной подписи
function validateRequests($request,$web_key)
{
    $signature_checked = -1;
    if (isset($request['order_mer_code']) &&
        isset($request['sum']) &&
        isset($request['mer_no']) &&
        isset($request['card']) &&
        isset($request['purch_date'])
    ) {
        $signature_checked = 0;
        $hash = md5($request['order_mer_code'] .
            $request['sum'] .
            $request['mer_no'] .
            $request['card'] .
            $request['purch_date'] .
            $web_key);
        if ($hash == $request['notify_signature']) {

            $signature_checked = 1;
        }
    }
    return $signature_checked;
}